#!/usr/bin/perl
use strict;

use Encode::Guess;

my $Prolog = {};

our $target = shift;
our $code = sub {
  my ($entity, $file_name) = @_;

  if ($entity->{body} =~ /^((?:(?!<html).)*?<!DOCTYPE[^>]*>)/is) {
    my $p = $1;
    $p =~ s/[\x09-\x0D\x20]+/ /g;
    $p =~ s/<!--[^>]*-->/<!---->/g;
    $p =~ s/<!----> ?(?><!----> ?)+/<!---->/g;
    $p =~ s/^ //;
    $Prolog->{$p}++;
  } else {
    $Prolog->{'(none)'}++;
  }
};

require 'foreach.pl';

print "Prolog:\n";
for (sort {$a cmp $b} keys %$Prolog) {
  my $n = $_;
  $n =~ s/([\x00-\x1F\x25\x7F-\xFF])/sprintf '%%%02X', ord $1/ge;
  print $n, "\t", $Prolog->{$_}, "\n";
}

=head1 AUTHOR

Wakaba <w@suika.fam.cx>.

=head1 LICENSE

Copyright 2007 Wakaba <w@suika.fam.cx>

This library is free software; you can redistribute it
and/or modify it under the same terms as Perl itself.

=cut

1;
## $Date: 2007/06/03 13:52:14 $

