#!/usr/bin/perl
use strict;

use Encode::Guess;

my $GuessEncode = {};

our $target = shift;
our $code = sub {
  my ($entity, $file_name) = @_;

  my $enc = guess_encoding
    ($entity->{body}, qw/euc-jp shiftjis 7bit-jis/);
  $GuessEncode->{ref $enc ? $enc->name : $enc}++;
  print $file_name, "\t", $enc, "\n" unless ref $enc;
};

require 'foreach.pl';

print "Guessed encoding:\n";
for (sort {$a cmp $b} keys %$GuessEncode) {
  print $_, "\t", $GuessEncode->{$_}, "\n";
}

=head1 AUTHOR

Wakaba <w@suika.fam.cx>.

=head1 LICENSE

Copyright 2007 Wakaba <w@suika.fam.cx>

This library is free software; you can redistribute it
and/or modify it under the same terms as Perl itself.

=cut

1;
## $Date: 2007/06/02 12:12:28 $

