#!/usr/bin/perl
use strict;

our $target;
our $code;

my $data_dir_name = $target eq 'ruby' ? q<../.rubydata/> : $target ? q<../.> . $target . q</> : q<../.data/>;

my $failed = 0;
my $dir_id = 0;
while (1) {
  last unless -d "$data_dir_name$dir_id";
  print STDERR "*";
  for my $t_l (qw/t l/, 0, 10, 20, 30, 40, 50, 60, 70, 80, 90, 100) {
    for my $local_id (0..9) {
      my $file_name = "$data_dir_name$dir_id/$t_l-$local_id.html";
      next unless -f $file_name;
      open my $file, '<', $file_name or (++$failed and next);
      my $entity = {};

      ## Very simplified version of HTTP header processing
      my $line = <$file>;
      if (defined $line and $line =~ m!^(\S+)\s+(\S+)\s+(.*)!) {
        $entity->{protocol_version} = $1;
        $entity->{status_code} = $2;
        $entity->{status_phrase} = $3;
        $line = <$file>;
      } else {
        $failed++;
        next;
      }

      while (defined $line and $line !~ /^$/) {
        $line =~ tr/\x0D\x0A//d;
        if ($line =~ s/^([^:]+)://) {
          push @{$entity->{field}->{lc $1} ||= []}, $line;
        }
        $line = <$file>;
      }

      $line = <$file> if defined $line and $line =~ /^$/;
      
      $entity->{body} = '';
      while (defined $line) {
        $entity->{body} .= $line;
        $line = <$file>;
      }

      $code->($entity, $file_name, $dir_id);
    }
  }
  $dir_id++;
}

print STDERR "\n";
print STDERR "$failed errors\n" if $failed;

1;

=head1 AUTHOR

Wakaba <w@suika.fam.cx>.

=head1 LICENSE

Copyright 2007 Wakaba <w@suika.fam.cx>

This library is free software; you can redistribute it
and/or modify it under the same terms as Perl itself.

=cut

1;
## $Date: 2007/07/21 05:26:47 $
